SSL_GET_PEER_CERTIFICATE(3)

NAME
SSL_get_peer_certificate - get the X509 certificate of the peer

SYNOPSIS
libssl libcrypto
#include <openssl/ssl.h>
X509 *
SSL_get_peer_certificate(const SSL *ssl);

DESCRIPTION
SSL_get_peer_certificate() returns a pointer to the X509 certificate the peer presented. If the peer did not present a certificate, NULL is returned.

Due to the protocol definition, a TLS/SSL server will always send a certificate, if present. A client will only send a certificate when explicitly requested to do so by the server (see SSL_CTX_set_verify(3)). If an anonymous cipher is used, no certificates are sent.

That a certificate is returned does not indicate information about the verification state. Use SSL_get_verify_result(3) to check the verification state.

The reference count of the X509 object is incremented by one, so that it will not be destroyed when the session containing the peer certificate is freed. The X509 object must be explicitly freed using X509_free(3).

RETURN VALUES
The following return values can occur:

NULL
    No certificate was presented by the peer or no connection was established.

Pointer to an X509 certificate
    The return value points to the certificate presented by the peer.

SEE ALSO
ssl(3), SSL_CTX_set_verify(3), SSL_get0_peername(3), SSL_get_verify_result(3)

HISTORY
SSL_get_peer_certificate() appeared in SSLeay 0.4 or earlier and has been available since OpenBSD 2.4.